
@echo off


rem 	Batchdatei   ~~   D(sl)ON A(ir) L(og)IN   ~~  "donalin.cmd" 
rem
rem 	~~~~~~~~~~   Datum: 20.12.2005  Version: 0.1    ~~~~~~~~~~~
rem
rem 	~~~~~~~~~~   Datum:             Version:        ~~~~~~~~~~~
rem
rem 	~~~~~~~~~~   Datum:             Version:        ~~~~~~~~~~~
rem
rem 	Autor: Karl M. Weckler         (http://www.rockenberg.net/)
rem
rem
rem 	Das Script ist Frei. Die Nutzung erfolgt auf eigene Gefahr!
rem
rem 	~~~~~~~~~~  Der Autor bernimmt KEINE Haftung!  ~~~~~~~~~~~
rem
rem 	Feedback,  Kritik  und  Verbesserungsvorschlge  bitte  an:
rem
rem 	~~~~~~~~~~      mail(at)rockenberg(dot)net      ~~~~~~~~~~~


rem ----[Kurzbeschreibung]-------------------------------------------------
rem
rem Dieses Batchprogramm (DOS-Skript) prft zunchst den Status der WLan-
rem Verbindung zu DSLonAir.
rem
rem Im Online Status erfolgt keine weitere Aktion.
rem Im Offline Status fhrt das Programm einen Login zu DSLonAir aus.
rem
rem Die Anmeldung per HTTPS an den Host DBD.DSLONAIR.DE erfolgt erst
rem nach Prfung der Verbindung und der URL.
rem
rem Das Programm sollte mit dem Task-Manager regelmig aufgerufen werden. 
rem (z.B. alle 3 bis 5 Minuten). Hierzu erstellen Sie eine Verknpfung zu
rem donalin.cmd und stellen in deren Eigenschaften die Option "Ausfhren"
rem auf "minimiert." Diese Verknpfung dann im Task-Manager mit den ent-
rem sprechenden Einstellungen ausfhren lassen.
rem
rem Die Idee zu diesem Skript wurde initiiert durch das Linux-Skript
rem "DSL-Login" von Ulf Leichsenring (http://www.lug-stormarn.de/dsl.php).
rem hnlichkeiten sind rein zufllig :-)).


rem ----[Erforderliche Dateien / Programme]--------------------------------
rem
rem Bentigt wird das Tool "cURL fr Windows32 SSL".
rem Download ber: (http://curl.haxx.se/)
rem Die Datei "cURL.EXE" und das zugehrige Zertifikat "curl-ca-bundle.crt"
rem werden in das Windows Verzeichnis kopiert.
rem (oder hilfsweise in ein anderes unter "Path" angegebenes Verzeichnis)
rem 
rem Bentigt wird auch "Win32OpenSSL" (http://www.openssl.org/)
rem Bitte entsprechend installieren.
rem
rem Weiter wird bentigt Die Datei (DON_UES_INI). 
rem Nheres hierzu unter [Prozessablauf].
  

rem ----[Prozessablauf]----------------------------------------------------
rem
rem Was das Script 'sonst noch so' macht?
rem 
rem Da wir hier mit "dem guten, alten" MSDOS arbeiten und uns ausser den 
rem Umgebungsvariablen (Environment Variable) nichts geboten wird, mssen
rem whrend des Prozessablaufes ein 'paar' Hilfsdateien erzeugt werden.
rem Dazu wird zunchst ein Unterverzeichnis "Donalin" im Standard-Windows-
rem Verzeichnis "Gemeinsame Dokumente" (%allusersprofile%\dokumente\) 
rem angelegt. In diesem Verzeichnis finden sich whrend des Prozesses alle
rem Hilfsdateien. Dort findet sich auch das Logfile "donalin.log" in dem 
rem HTTP-Codes, Datum und Zeit, evtl. Fehler, Logins, Hinweise etc. 
rem dokumentiert werden.
rem
rem Nach Beendigung des Prozesses werden alle Hilfsdateien -bis auf die 
rem (DON_UES_INI) und alle Umgebungsvariablen gelscht, so dass ein sauberes
rem System zurck bleibt.
rem
rem Wie oben bereits gesagt, wird die Hilfsdatei (DON_UES_INI) bentigt. 
rem Sie hat den Inhalt: "--URL =" (WICHTIG: OHNE "" und OHNE CR/LF).
rem Diese Datei muss im Standardverzeichnis: "Gemeinsame Dokumente\Donalin"
rem liegen, sie darf nicht gelscht oder verndert werden,
rem denn: OHNE diese Datei geht NIX!   
rem 
rem Wenn Sie die beiden Dateien (DonALin.cmd und DON_UES_INI) gedownloadet
rem haben, installiert DonALin.cmd die DON_UES_INI beim ersten Aufruf im
rem Donalin-Standardverzeichnis, so dass Sie weiter nichts zu unternehmen
rem brauchen. Wenn Sie DonALin.cmd per cut'n paste selbst erstellt haben, 
rem mssen Sie auch die DON_UES_INI entsprechend erstellen, denn wie gesagt:
rem OHNE DON_UES_INI geht NIX! 


:TOP
rem ----[00.Konfigurationsparameter]---------------------------------------
rem
rem Sie knnen die vorgegebene Test-URL (DON_TST_URL) benutzen. Der Autor
rem kann aber die Verfgbarkeit nicht garantieren, weder heute noch in Zukunft.
rem
rem Sie knnen auch sonst jede Internet-Seite verwenden (eigen oder fremd).
rem Es werden keine geheimen (Name/Passwort) Daten an diese URL gesendet! 
rem Die (DON_TST_URL) wird bentigt, um den HTTP-Statuscode zu liefern.
rem Deshalb sollte diese Seite mglichst klein (leer) sein, um nicht das
rem DSL Volumen schon durch die regelmigen Online-Requests ber Gebhr
rem zu beanspruchen ;-).
rem
rem Der Login-Host (DON_HOST) ist voreingestellt auf HTTPS://DBD.DSLONAIR.DE
rem und sollte -ohne Not- nicht verndert werden.
rem
rem Bei (DON_USR) und (DON_PWD) geben Sie Ihre DSL-Zugangsdaten ein:
rem Bei (DON_USR) Ihren Namen "UserID"  z.B.: DBDxyzzyx
rem Bei (DON_PWD) Ihr Passwort
rem
rem Mit Log-Online (DON_LOL) knnen Sie festlegen, ob die regelmige Prfung
rem des Online-Status ins Logfile geschrieben wird. Diese Funktion ist, wie 
rem der Name LOL schon verrt, eher ein Gimmick. Mit DON_LOL=1 wird gelogt.  
rem Das Loggen von Fehlern, Login etc. ist von dieser Einstellung unabhngig
rem und kann (standardmssig) nicht deaktiviert werden. 

rem ----[Hier die individuellen Parameter eintragen:]-----------------------
  
set DON_TST_URL=http://www.rockenberg.net/donalin/nix.htm
set DON_HOST=https://dbd.dslonair.de/

set DON_USR=Hier Ihren Namen/User eingeben
set DON_PWD=Hier Ihr Passwort eingeben

set DON_LOL=

rem ----[Ende Konfigurationsparameter]--------------------------------------


rem ************************************************************************
rem ---- Ab hier nur noch ndern, wenn Sie wissen, was Sie tun! ------------
rem ************************************************************************

rem !Achtung! Im Debug Modus (DON_DBG=1) kann das Programm nicht arbeiten!
rem Deshalb nur zum Testen in den Debug Modus wechseln.
set DON_DBG=
if "%DON_DBG%"=="1" (set #=echo) else (set #=rem)
if "%DON_DBG%"=="1" (set ##=rem) else (set ##= )


%#% ----[01.Verzeichnis und Logfile anlegen]--------------------------------
rem Verzeichnis "Donalin" anlegen im Windows-Standard-Verzeichnis
rem "Gemeinsame Dokumente" und Logfile "donalin.log" generieren.
rem Kopieren von DON_UES_INI.

set DON_DIR=%allusersprofile%\dokumente\Donalin\
if not exist "%DON_DIR%" md "%DON_DIR%"
if not exist "%DON_DIR%DON_UES_INI" goto UES_INI
cd /d %DON_DIR%
set DON_LOG=%DON_DIR%donalin.log
if exist "%DON_LOG%" goto ONTEST
echo Logfile:   Einwahlen zu DSLonAir                    ber Donalin.cmd> "%DON_LOG%"
echo -------------------------------------------------------------------->> "%DON_LOG%"
echo Erstellt:  %date%  %time%	>> "%DON_LOG%"
echo -------------------------------------------------------------------->> "%DON_LOG%"
echo ---------^|----------^|-----------^|----------------------------------->> "%DON_LOG%"
echo HTTP-Code^|Datum     ^|Zeit       ^|Login-Host / * Hinweis / # Fehler  >> "%DON_LOG%"
echo ---------^|----------^|-----------^|----------------------------------->> "%DON_LOG%"


:ONTEST
%#% ----[02.Online Test]---------------------------------------------------- 
rem Testen, ob eine http-Verbindung zum Internet (zur DON_TST_URL) mglich ist.
rem Der HTTP-Statuscode wird abgefragt und in (DON_HC1) gespeichert.
rem Die gelufigen Codes werden ausgewertet.
rem Die Optionen von cURL finden sich in der man page.

curl -s -o /dev/null -w %%{http_code} %DON_TST_URL% > "%DON_DIR%DON_HC1"
find "200" "%DON_DIR%DON_HC1" > nul
if %errorlevel% == 0 goto ONLINE
find "302" "%DON_DIR%DON_HC1" > nul
if %errorlevel% == 0 goto HOLURL 
find "000" "%DON_DIR%DON_HC1" > nul
if %errorlevel% == 0 goto NOLINE
find "404" "%DON_DIR%DON_HC1" > nul
if %errorlevel% == 0 goto NOFIND
type "%DON_DIR%DON_HC1" >> "%DON_LOG%"
echo       ^|%date%^|%time%^|# Onlinetest abgebrochen >> "%DON_LOG%"
goto AUFWASCH


:HOLURL
%#% ----[03.Cookie und effektive URL holen]---------------------------------
rem Die effective URL (DON_UEF) der Loginseite ermitteln (wir hngen an
rem einem Redirekt!) und Cookie speichern.
rem (DON_UEF) in sendefhige URL (DON_UES) umwandeln.

curl -s -o /dev/null -L -c DON_COC -w "%%{url_effective}" %DON_TST_URL% > "%DON_DIR%DON_UEF"
copy "%DON_DIR%DON_UES_INI"+"%DON_DIR%DON_UEF" "%DON_DIR%DON_UES" >nul


%#% ----[04.HTTPS-Verbindung und Host prfen]-------------------------------
rem Wir vergleichen unsere vorgegebene Hostadresse (DON_HOST) mit der vom
rem Redirekt bertragenen Hostadresse (DON_UES); bei bereinstimmung erfolgt
rem Anmeldung, bei Abweichung erfolgt keine Anmeldung.

find "%DON_HOST%" "%DON_DIR%DON_UES" >nul
if %errorlevel% == 0 goto HOSTOK
goto HOSTNOK


:HOSTOK
%#% ----[05.Host O.K. - Anmeldung durchfhren und loggen]-------------------
rem Die vorgegebene Hostadresse (DON_HOST) entspricht der vom Redirekt
rem bertragenen Adresse (DON_UES). Die Anmeldung erfolgt.
rem Loginparameter (User/Password) werden per HTTPS POST zusammen mit dem
rem gespeicherten Cookie an die bertragene URL (DON_UES) gesendet.
rem Speichern des HTTP-CODE in (DON_HC2) und loggen.

curl -s -o /dev/null -b DON_COC -w %%{http_code} -d "__ac_name=%DON_USR%" -d "__ac_password=%DON_PWD%" -K "%DON_DIR%DON_UES" > "%DON_DIR%DON_HC2"
find "200" "%DON_DIR%DON_HC2" >nul
if %errorlevel% EQU 0 echo 200      ^|%date%^|%time%^|%DON_HOST% >> "%DON_LOG%"
if %errorlevel% GTR 0 goto NOLOGIN
goto AUFWASCH


:HOSTNOK
%#% ----[06.Host N.O.K. - keine Anmeldung]----------------------------------
rem Die vorgegebene Hostadresse (DON_HOST) entspricht nicht der vom Redirekt
rem bertragenen Adresse. Deshalb erfolgt aus Sicherheitsgrnden keine Anmeldung.

echo ~~~~~~~~~^|~~~~~~~~~~^|~~~~~~~~~~~^|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~>> "%DON_LOG%"
echo 302      ^|%date%^|%time%^|# Falsche Login-Adresse: 	>> "%DON_LOG%"
type "%DON_DIR%DON_UEF"	>> "%DON_LOG%"
echo .>> "%DON_LOG%"
echo Aus Sicherheitsgrnden erfolgte keine Anmeldung!		>> "%DON_LOG%"
echo ~~~~~~~~~^|~~~~~~~~~~^|~~~~~~~~~~~^|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~>> "%DON_LOG%"
goto AUFWASCH


:ONLINE
%#% ----[07.Onlinestatus protokollieren]------------------------------------
rem Die Prfung ergab: Wir sind online.
rem Ein entsprechender Eintrag ins Logfile erfolgt nur, sofern im Abschnitt 
rem [00.Konfigurationsparameter] die Variable (DON_LOL) auf "1" ohne ""
rem gesetzt wurde.  

if not "%DON_LOL%" =="1" goto Aufwasch
type "%DON_DIR%DON_HC1" >> "%DON_LOG%"
echo       ^|%date%^|%time%^|* Onlinetest erfolgreich >> "%DON_LOG%"
goto AUFWASCH


:NOLINE
%#% ----[08.Onlineprfung protokollieren HTTP-Code: 000]--------------------
rem Die Prfung ergab: Keine Verbindung zum Internet

type "%DON_DIR%DON_HC1" >> "%DON_LOG%"
echo       ^|%date%^|%time%^|# Keine Verbindung zum Internet >> "%DON_LOG%"
goto AUFWASCH


:NOFIND
%#% ----[09.Onlineprfung protokollieren HTTP-Code: 404]--------------------
rem Die Prfung ergab: Test-URL nicht gefunden

type "%DON_DIR%DON_HC1" >> "%DON_LOG%"
echo       ^|%date%^|%time%^|# Die Test-URL nicht gefunden >> "%DON_LOG%"
goto AUFWASCH


:NOLOGIN
%#% ----[10.Loginfehler]----------------------------------------------------
rem Die Prfung ergab: Loginfehler

type "%DON_DIR%DON_HC2" >> "%DON_LOG%"
echo       ^|%date%^|%time%^|# Loginfehler >> "%DON_LOG%"
goto AUFWASCH


:UES_INI
%#% ----[11.Kopieren der DON_UES_INI]---------------------------------------
rem Die DON_UES_INI wird aus dem Installationsverzeichnis installiert,
rem falls nicht vorhanden, wird ein Fehlertext ausgegeben.

if not exist DON_UES_INI goto NO_INI
copy DON_UES_INI "%DON_DIR%DON_UES_INI"
goto TOP

:NO_INI
cls
echo.
echo # Fehler: Die Hilfsdatei "DON_UES_INI" fehlt.
echo.
echo Abhilfe 1: Datei von www.rockenberg.net/donalin downloaden
echo oder
echo Abhilfe 2: Erstellen Sie die Datei mit einem Editor selbst
echo 		Inhalt der Datei: "--url = " (ohne "" und ohne CR/LF)
echo.
echo.
echo Ohne diese Datei ist Donalin.cmd nicht lauffhig!
pause
if exist DON_UES_INI goto TOP
goto AUFWASCH

		 
:AUFWASCH
%#% ----[11.Der Letzte macht den Aufwasch]----------------------------------
%##% if exist "%DON_DIR%DON_HC1" del "%DON_DIR%DON_HC1"
%##% if exist "%DON_DIR%DON_HC2" del "%DON_DIR%DON_HC2"
%##% if exist "%DON_DIR%DON_UEF" del "%DON_DIR%DON_UEF"
%##% if exist "%DON_DIR%DON_UES" del "%DON_DIR%DON_UES"
%##% if exist DON_COC del DON_COC
%##% set DON_TST_URL=
%##% set DON_HOST=
%##% set DON_USR=
%##% set DON_PWD=
%##% set DON_LOG=
%##% set DON_LOL=
%##% set DON_DBG=
%##% set DON_DIR=
%##% set DON_INT=
%##% set ##=
%##% set #=
cd /d %windir%


:ENDE
rem ----[12.Ende Skript]----------------------------------------------------